Index: /code/trunk/src/libraries/network/WANDiscovery.cc
===================================================================
--- /code/trunk/src/libraries/network/WANDiscovery.cc	(revision 7801)
+++ /code/trunk/src/libraries/network/WANDiscovery.cc	(revision 7801)
@@ -0,0 +1,167 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau (original)
+ *   Co-authors:
+ *      Sandro 'smerkli' Merkli (adaptions to WAN)
+ *      ...
+ *
+ */
+
+#include "WANDiscovery.h"
+
+#include <enet/enet.h>
+#include <cstring>
+
+#include "util/ScopedSingletonManager.h"
+#include "core/CoreIncludes.h"
+
+
+namespace orxonox
+{
+  ManageScopedSingleton(WANDiscovery, ScopeID::Graphics, true);
+
+
+  WANDiscovery::WANDiscovery()
+  {
+    /* debugging output */
+    COUT(4) << "Creating WANDiscovery.\n";
+  
+    /* register object in orxonox */
+    RegisterObject(WANDiscovery);
+
+    /* check for the masterserver address option in orxonox.ini */
+    this->setConfigValues();
+
+    /* initialize it and see if it worked */
+    if( msc.initialize() )
+      COUT(2) << "Error: could not initialize master server communications!\n";
+
+    /* connect and see if it worked */
+    if( msc.connect( this->msaddress.c_str(), ORX_MSERVER_PORT ) )
+      COUT(2) << "Error: could not connect to master server at " 
+        << this->msaddress << std::endl;
+
+    /* debugging output */
+    COUT(4) << "Initialization of WANDiscovery complete.\n";
+  }
+
+  void WANDiscovery::setConfigValues()
+  {
+    /* update msaddress string from orxonox.ini config file, if it 
+     * has changed. 
+     */
+    SetConfigValue( msaddress, "orxonox.net");
+  } 
+
+  WANDiscovery::~WANDiscovery()
+  { 
+    /* clear server list */
+    this->servers_.clear();  
+  }
+
+  /* callback for the network reply poller */
+  int rhandler( char *addr, ENetEvent *ev )
+  { 
+    /* error recognition */
+    if( !ev || !ev->packet || !ev->packet->data )
+    { COUT(2) << "Bad arguments received in WANDiscovery's reply handler.\n";
+      return 0;
+    }
+
+    /* handle incoming data */
+    /* if a list entry arrives add to list */
+    if( !strncmp( (char*)ev->packet->data, MSPROTO_SERVERLIST_ITEM,
+      MSPROTO_SERVERLIST_ITEM_LEN ) )
+    { 
+      /* create server structure from that item */
+      packet::ServerInformation toadd;
+
+      /* fill in data, -1 for the index: index should be length -1 */
+      toadd.setServerName( std::string((char*)ev->packet->data + 
+        MSPROTO_SERVERLIST_ITEM_LEN+1) );
+      toadd.setServerIP( std::string((char*)ev->packet->data + 
+        MSPROTO_SERVERLIST_ITEM_LEN+1) );
+
+      /* add to list */
+      WANDiscovery::getInstance().servers_.push_back( toadd );
+    }
+    else if( !strncmp( (char*)ev->packet->data, MSPROTO_SERVERLIST_END,
+      MSPROTO_SERVERLIST_END_LEN ) )
+    { 
+      /* this is the only case where 2 should be returned,
+       * as 1 is used to signal that we're done receiving
+       * the list
+       */
+      return 2; 
+    }
+
+    /* done handling, return all ok code 0 */
+    return 1;
+  }
+ 
+  void WANDiscovery::discover()
+  {
+    /* clear list */
+    this->servers_.clear();
+
+    /* send request to server */
+    this->msc.sendRequest( MSPROTO_CLIENT " " MSPROTO_REQ_LIST );
+
+    /* poll for replies */
+    int i = WANDISC_MAXTRIES;
+    while( i > 0 )
+    {
+      /* poll for reply and act according to what was received */
+      switch( this->msc.pollForReply( rhandler, 500 ) )
+      { case 0: /* no event occured, decrease timeout */
+          --i; break;
+        case 1: /* got a list element, continue */ 
+          break;
+        case 2: /* done. */
+          i = 0; break;
+      }
+    }
+  }
+
+  std::string WANDiscovery::getServerListItemName(unsigned int index)
+  {
+    /* if the index is out of range, return empty */
+    if( index >= this->servers_.size() )
+      return BLANKSTRING;
+    else
+      /* else return the name of the server */
+      return this->servers_[index].getServerName();
+  }
+
+  std::string WANDiscovery::getServerListItemIP(unsigned int index)
+  {
+    /* if the index is out of range, return empty */
+    if( index >= this->servers_.size() )
+      return BLANKSTRING;
+    else
+      /* else return the IP of the server */
+      return this->servers_[index].getServerIP();
+  }
+
+
+} // namespace orxonox
Index: /code/trunk/src/libraries/network/WANDiscovery.h
===================================================================
--- /code/trunk/src/libraries/network/WANDiscovery.h	(revision 7801)
+++ /code/trunk/src/libraries/network/WANDiscovery.h	(revision 7801)
@@ -0,0 +1,112 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or modify it
+ *   under the terms of the GNU General Public License as published by the Free
+ *   Software Foundation; either version 2 of the License, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful, but
+ *   WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
+ *   or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ *   for more details.
+ *
+ *   You should have received a copy of the GNU General Public License along
+ *   with this program; if not, write to the Free Software Foundation, Inc., 51
+ *   Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author: Fabian 'x3n' Landau (original) Co-authors: Sandro 'smerkli' Merkli
+ *   (copied and adapted to WAN)
+ *
+ */
+
+#ifndef _WANDiscovery_H__
+#define _WANDiscovery_H__
+
+#include "NetworkPrereqs.h"
+#include "packet/ServerInformation.h"
+#include "core/ConfigFileManager.h"
+#include "util/Singleton.h"
+#include "core/OrxonoxClass.h"
+#include "core/ConfigValueIncludes.h"
+#include "core/CoreIncludes.h"
+#include "MasterServerComm.h"
+#include "MasterServerProtocol.h"
+
+#include <vector>
+
+#define WANDISC_MAXTRIES 5
+
+// tolua_begin
+namespace orxonox
+{
+
+  class _NetworkExport WANDiscovery
+// tolua_end
+    : public Singleton<WANDiscovery>, public OrxonoxClass
+  { // tolua_export
+    friend class Singleton<WANDiscovery>;
+    public:
+      /** constructor */
+      WANDiscovery();
+
+      /** destructor */
+      ~WANDiscovery();
+
+      /** \return Address of the master server
+       * 
+       * Get the master server address 
+       */
+      std::string getMSAddress()
+      { return this->msaddress; }
+
+      /** ask server for server list  */
+      void discover(); // tolua_export
+
+      /** \param index Index to get the name of 
+       * \return The name of the server
+       * 
+       * Get the name of the server at index index. 
+       */
+      std::string getServerListItemName( unsigned int index ); // tolua_export
+
+      /** \param index Index to get the IP of 
+       * \return The IP of the server
+       * 
+       * Get the IP of the server at index index. 
+       */
+      std::string getServerListItemIP( unsigned int index ); // tolua_export
+
+      /** \return an instance of WANDiscovery
+       * 
+       * Create and return an instance of WANDiscovery.
+       */
+      static WANDiscovery& getInstance() { return Singleton<WANDiscovery>::getInstance(); } // tolua_export
+    
+      /* todo: might make this private and use getter/setter methods
+       * at some later time. 
+       */
+      /** game server list */
+      std::vector<packet::ServerInformation> servers_;
+
+      /** Function used for the configuration file parameter update */
+      void setConfigValues();
+
+      /** Master server communications object */
+      MasterServerComm msc;
+      
+    private:
+      /** Singleton pointer */
+      static WANDiscovery* singletonPtr_s;
+
+      /** master server address */
+      std::string msaddress;
+
+  }; // tolua_export
+
+} // tolua_export
+
+#endif // _WANDiscovery_H__
Index: /code/trunk/src/libraries/network/packet/Acknowledgement.cc
===================================================================
--- /code/trunk/src/libraries/network/packet/Acknowledgement.cc	(revision 7800)
+++ /code/trunk/src/libraries/network/packet/Acknowledgement.cc	(revision 7801)
@@ -31,4 +31,5 @@
 #include "util/Debug.h"
 #include "network/GamestateHandler.h"
+#include "network/Host.h"
 
 namespace orxonox {
@@ -39,5 +40,5 @@
 #define _ACKID              _PACKETID + sizeof(packet::Type::Value)
 
-Acknowledgement::Acknowledgement( unsigned int id, unsigned int clientID )
+Acknowledgement::Acknowledgement( unsigned int id, unsigned int peerID )
  : Packet()
 {
@@ -46,9 +47,9 @@
   *(Type::Value *)(data_ + _PACKETID ) = Type::Acknowledgement;
   *(uint32_t *)(data_ + _ACKID ) = id;
-  clientID_=clientID;
+  peerID_=peerID;
 }
 
-Acknowledgement::Acknowledgement( uint8_t *data, unsigned int clientID )
-  : Packet(data, clientID)
+Acknowledgement::Acknowledgement( uint8_t *data, unsigned int peerID )
+  : Packet(data, peerID)
 {
 }
@@ -62,7 +63,7 @@
 }
 
-bool Acknowledgement::process(){
+bool Acknowledgement::process(orxonox::Host* host){
   COUT(5) << "processing ACK with ID: " << getAckID() << endl;
-  bool b = GamestateHandler::ackGamestate(getAckID(), clientID_);
+  bool b = host->ackGamestate(getAckID(), peerID_);
   delete this;
   return b;
Index: /code/trunk/src/libraries/network/packet/Acknowledgement.h
===================================================================
--- /code/trunk/src/libraries/network/packet/Acknowledgement.h	(revision 7800)
+++ /code/trunk/src/libraries/network/packet/Acknowledgement.h	(revision 7801)
@@ -42,10 +42,10 @@
 {
 public:
-  Acknowledgement( unsigned int id, unsigned int clientID );
-  Acknowledgement( uint8_t* data, unsigned int clientID );
+  Acknowledgement( unsigned int id, unsigned int peerID );
+  Acknowledgement( uint8_t* data, unsigned int peerID );
   ~Acknowledgement();
 
   inline unsigned int getSize() const;
-  bool process();
+  virtual bool process(orxonox::Host* host);
 
   unsigned int getAckID();
Index: /code/trunk/src/libraries/network/packet/Chat.cc
===================================================================
--- /code/trunk/src/libraries/network/packet/Chat.cc	(revision 7800)
+++ /code/trunk/src/libraries/network/packet/Chat.cc	(revision 7801)
@@ -80,6 +80,6 @@
 }
 
-bool Chat::process(){
-  bool b = Host::incomingChat(std::string((const char*)data_+_MESSAGE), *(uint32_t *)(data_+_PLAYERID));
+bool Chat::process(orxonox::Host* host){
+  bool b = host->incomingChat(std::string((const char*)data_+_MESSAGE), *(uint32_t *)(data_+_PLAYERID));
   delete this;
   return b;
Index: /code/trunk/src/libraries/network/packet/Chat.h
===================================================================
--- /code/trunk/src/libraries/network/packet/Chat.h	(revision 7800)
+++ /code/trunk/src/libraries/network/packet/Chat.h	(revision 7801)
@@ -52,5 +52,5 @@
 
   /* process chat message packet and remove it afterwards */
-  bool process();
+  virtual bool process(orxonox::Host* host);
 
   /* Get the length of the message (not the full size of the packet) */
Index: /code/trunk/src/libraries/network/packet/ClassID.cc
===================================================================
--- /code/trunk/src/libraries/network/packet/ClassID.cc	(revision 7800)
+++ /code/trunk/src/libraries/network/packet/ClassID.cc	(revision 7801)
@@ -120,5 +120,5 @@
 
 
-bool ClassID::process(){
+bool ClassID::process(orxonox::Host* host){
   int nrOfClasses;
   uint8_t *temp = data_+sizeof(uint32_t); //skip the packetid
Index: /code/trunk/src/libraries/network/packet/ClassID.h
===================================================================
--- /code/trunk/src/libraries/network/packet/ClassID.h	(revision 7800)
+++ /code/trunk/src/libraries/network/packet/ClassID.h	(revision 7801)
@@ -48,5 +48,5 @@
 
   uint32_t getSize() const;
-  bool process();
+  virtual bool process(orxonox::Host* host);
 
 private:
Index: /code/trunk/src/libraries/network/packet/DeleteObjects.cc
===================================================================
--- /code/trunk/src/libraries/network/packet/DeleteObjects.cc	(revision 7800)
+++ /code/trunk/src/libraries/network/packet/DeleteObjects.cc	(revision 7801)
@@ -57,5 +57,6 @@
 }
 
-bool DeleteObjects::fetchIDs(){
+bool DeleteObjects::fetchIDs()
+{
   unsigned int number = Synchronisable::getNumberOfDeletedObject();
   if(number==0)
@@ -79,11 +80,14 @@
 }
 
-unsigned int DeleteObjects::getSize() const{
+unsigned int DeleteObjects::getSize() const
+{
   assert(data_);
   return _OBJECTIDS + *(uint32_t*)(data_+_QUANTITY)*sizeof(uint32_t);
 }
 
-bool DeleteObjects::process(){
-  for(unsigned int i=0; i<*(unsigned int *)(data_+_QUANTITY); i++){
+bool DeleteObjects::process(orxonox::Host* host)
+{
+  for(unsigned int i=0; i<*(unsigned int *)(data_+_QUANTITY); i++)
+  {
     COUT(4) << "deleting object with id: " << *(uint32_t*)(data_+_OBJECTIDS+i*sizeof(uint32_t)) << std::endl;
     Synchronisable::deleteObject( *(uint32_t*)(data_+_OBJECTIDS+i*sizeof(uint32_t)) );
Index: /code/trunk/src/libraries/network/packet/DeleteObjects.h
===================================================================
--- /code/trunk/src/libraries/network/packet/DeleteObjects.h	(revision 7800)
+++ /code/trunk/src/libraries/network/packet/DeleteObjects.h	(revision 7801)
@@ -32,6 +32,8 @@
 #include "Packet.h"
 
-namespace orxonox {
-namespace packet {
+namespace orxonox
+{
+namespace packet
+{
 /**
     @author
@@ -47,5 +49,5 @@
 
   inline unsigned int getSize() const;
-  bool process();
+  virtual bool process(orxonox::Host* host);
 
 private:
Index: /code/trunk/src/libraries/network/packet/FunctionCalls.cc
===================================================================
--- /code/trunk/src/libraries/network/packet/FunctionCalls.cc	(revision 7800)
+++ /code/trunk/src/libraries/network/packet/FunctionCalls.cc	(revision 7801)
@@ -32,4 +32,5 @@
 #include "network/FunctionCall.h"
 #include "network/FunctionCallManager.h"
+#include "network/GamestateHandler.h"
 
 namespace orxonox {
@@ -40,13 +41,13 @@
 const unsigned int FUNCTIONCALLS_MEM_ALLOCATION = 1000;
 
-FunctionCalls::FunctionCalls()
- : Packet()
+FunctionCalls::FunctionCalls():
+  Packet(), minGamestateID_(GAMESTATEID_INITIAL)
 {
   flags_ = flags_ | PACKET_FLAGS_FUNCTIONCALLS;
-  currentSize_ = 2*sizeof(uint32_t); // for packetid and nrOfCalls
+  currentSize_ = 3*sizeof(uint32_t); // for packetid, nrOfCalls and minGamestateID_
 }
 
-FunctionCalls::FunctionCalls( uint8_t* data, unsigned int clientID )
-  : Packet(data, clientID)
+FunctionCalls::FunctionCalls( uint8_t* data, unsigned int clientID ): 
+  Packet(data, clientID), minGamestateID_(GAMESTATEID_INITIAL)
 {
 }
@@ -57,9 +58,12 @@
 
 
-bool FunctionCalls::process(){
+bool FunctionCalls::process(orxonox::Host* host)
+{
   assert(isDataENetAllocated());
   
   uint8_t* temp = data_+sizeof(uint32_t); //skip packetid
   uint32_t nrOfCalls = *(uint32_t*)temp;
+  temp += sizeof(uint32_t);
+  this->minGamestateID_ = *(uint32_t*)temp;
   temp += sizeof(uint32_t);
   for( unsigned int i = 0; i<nrOfCalls; i++ )
@@ -68,5 +72,7 @@
     fctCall.loadData(temp);
     if( !fctCall.execute() )
-      FunctionCallManager::bufferIncomingFunctionCall( fctCall );
+    {
+      FunctionCallManager::bufferIncomingFunctionCall( fctCall, minGamestateID_, this->getPeerID() );
+    }
   }
   
@@ -75,5 +81,6 @@
 }
 
-void FunctionCalls::addCallStatic( uint32_t networkID, const MultiType* mt1, const MultiType* mt2, const MultiType* mt3, const MultiType* mt4, const MultiType* mt5){
+void FunctionCalls::addCallStatic( uint32_t networkID, const MultiType* mt1, const MultiType* mt2, const MultiType* mt3, const MultiType* mt4, const MultiType* mt5)
+{
   assert(!isDataENetAllocated());
   
@@ -83,5 +90,6 @@
 }
 
-void FunctionCalls::addCallMember( uint32_t networkID, uint32_t objectID, const MultiType* mt1, const MultiType* mt2, const MultiType* mt3, const MultiType* mt4, const MultiType* mt5){
+void FunctionCalls::addCallMember( uint32_t networkID, uint32_t objectID, const MultiType* mt1, const MultiType* mt2, const MultiType* mt3, const MultiType* mt4, const MultiType* mt5)
+{
   assert(!isDataENetAllocated());
   
@@ -91,11 +99,13 @@
 }
 
-bool FunctionCalls::send()
+bool FunctionCalls::send(orxonox::Host* host)
 {
+  this->minGamestateID_ = host->getCurrentGamestateID();
   assert(this->functionCalls_.size());
   data_=new uint8_t[ currentSize_ ];
   *(Type::Value *)(data_ + _PACKETID ) = Type::FunctionCalls; // Set the Packet ID
-  *(uint32_t*)(data_+sizeof(uint32_t)) = this->functionCalls_.size(); // set nrOfCalls to 0
-  uint8_t* temp = data_+2*sizeof(uint32_t);
+  *(uint32_t*)(data_+sizeof(uint32_t)) = this->functionCalls_.size(); // set nrOfCalls
+  *(uint32_t*)(data_+2*sizeof(uint32_t)) = this->minGamestateID_; // set minGamestateID_
+  uint8_t* temp = data_+3*sizeof(uint32_t);
   
   while( this->functionCalls_.size() )
@@ -107,5 +117,5 @@
   assert( temp==data_+currentSize_ );
   
-  Packet::send();
+  Packet::send(host);
   return true;
 }
Index: /code/trunk/src/libraries/network/packet/FunctionCalls.h
===================================================================
--- /code/trunk/src/libraries/network/packet/FunctionCalls.h	(revision 7800)
+++ /code/trunk/src/libraries/network/packet/FunctionCalls.h	(revision 7801)
@@ -54,12 +54,13 @@
   inline unsigned int getSize() const
     { assert(!this->isDataENetAllocated()); return currentSize_; }
-  bool process();
+  virtual bool process(orxonox::Host* host);
 
   void addCallStatic( uint32_t networkID, const MultiType* mt1=0, const MultiType* mt2=0, const MultiType* mt3=0, const MultiType* mt4=0, const MultiType* mt5=0);
   void addCallMember( uint32_t networkID, uint32_t objectID, const MultiType* mt1=0, const MultiType* mt2=0, const MultiType* mt3=0, const MultiType* mt4=0, const MultiType* mt5=0);
-  virtual bool send();
+  virtual bool send(orxonox::Host* host);
 private:
   std::queue<orxonox::FunctionCall> functionCalls_;
   unsigned int                      clientID_;
+  uint32_t                          minGamestateID_;
   uint32_t                          currentSize_;
 };
Index: /code/trunk/src/libraries/network/packet/FunctionIDs.cc
===================================================================
--- /code/trunk/src/libraries/network/packet/FunctionIDs.cc	(revision 7800)
+++ /code/trunk/src/libraries/network/packet/FunctionIDs.cc	(revision 7801)
@@ -46,5 +46,6 @@
 
 
-FunctionIDs::FunctionIDs( ) : Packet(){
+FunctionIDs::FunctionIDs( ) : Packet()
+{
   unsigned int nrOfFunctions=0;
   unsigned int packetSize=2*sizeof(uint32_t); //space for the packetID and for the nroffunctions
@@ -55,5 +56,6 @@
   //calculate total needed size (for all strings and integers)
   ObjectList<NetworkFunctionBase>::iterator it;
-  for(it = ObjectList<NetworkFunctionBase>::begin(); it; ++it){
+  for(it = ObjectList<NetworkFunctionBase>::begin(); it; ++it)
+  {
     const std::string& functionname = it->getName();
     networkID = it->getNetworkID();
@@ -76,5 +78,6 @@
   // now save all classids and classnames
   std::pair<uint32_t, std::string> tempPair;
-  while( !tempQueue.empty() ){
+  while( !tempQueue.empty() )
+  {
     tempPair = tempQueue.front();
     tempQueue.pop();
@@ -98,5 +101,6 @@
 }
 
-uint32_t FunctionIDs::getSize() const{
+uint32_t FunctionIDs::getSize() const
+{
   assert(this->data_);
   uint8_t *temp = data_+sizeof(uint32_t); // packet identification
@@ -114,5 +118,6 @@
 
 
-bool FunctionIDs::process(){
+bool FunctionIDs::process(orxonox::Host* host)
+{
   int nrOfFunctions;
   uint8_t *temp = data_+sizeof(uint32_t); //skip the packetid
@@ -127,5 +132,6 @@
   temp += sizeof(uint32_t);
 
-  for( int i=0; i<nrOfFunctions; i++){
+  for( int i=0; i<nrOfFunctions; i++)
+  {
     networkID = *(uint32_t*)temp;
     stringsize = *(uint32_t*)(temp+sizeof(uint32_t));
Index: /code/trunk/src/libraries/network/packet/FunctionIDs.h
===================================================================
--- /code/trunk/src/libraries/network/packet/FunctionIDs.h	(revision 7800)
+++ /code/trunk/src/libraries/network/packet/FunctionIDs.h	(revision 7801)
@@ -47,6 +47,6 @@
   ~FunctionIDs();
 
-  uint32_t getSize() const;
-  bool process();
+  virtual uint32_t getSize() const;
+  virtual bool process(orxonox::Host* host);
 
 private:
